(*
   Title  : Fold.thy
   Author : M. Bortin
*)

theory Fold
imports Fold_Parameters
begin



theorem Fold_congruence :
"A \<in> TransformCond \<Longrightarrow> congruence (Fold A)"
apply(subst congruence_factor)
apply(rule TC_reduct)
apply(rule subset_trans)
apply(rule vimage_mono)
apply(rule Sigma_division)
apply clarsimp
apply(simp add: division_def ker_def)
apply clarify
apply(frule Transform_eqR)
apply(drule spec, drule mp, assumption)
apply(drule_tac f=A in arg_cong)
apply(subst (asm) Fold_Transform[where A=A], assumption+)
apply(subst Fold_eq)
apply(rule subsetD, rule TransformCond, assumption)
by simp


text {* Defining the fold function on the quotient type *}

constdefs
 FoldQ :: "(('a, 'b) \<Sigma> \<Rightarrow> 'b) \<Rightarrow> 'a TQ \<Rightarrow> 'b"
"FoldQ A \<equiv> (Fold A)\<^sup>#"


lemma FoldQ_eq : "A \<in> TransformCond \<Longrightarrow> FoldQ A <x> = Fold A x" 
apply(unfold FoldQ_def)
apply(subst ext1)
apply(erule Fold_congruence)
by (rule refl)


end
